from Products.FileSystemSite.DirectoryView import manage_addDirectoryView
from Products.Silva.install import add_fss_directory_view
from Products.Silva.interfaces import IMember

def install(root):
    """The view infrastructure for SilvaExtETHLDAP.
    """
    # create the core views from filesystem
    add_fss_directory_view(root.service_views, 'SilvaExtETHLDAP', __file__, 'views')
    # also register views
    registerViews(root.service_view_registry)
    # temporary hack: instead of during an upgrade we upgrade objects here
    # (so also on refresh_all)
    # XXX not sure if we want to leave this here, perhaps it's better to let
    # site admins remove all member objects, however these may potentially
    # contain a lot of data
    upgradeMemberObjects(root)

def uninstall(root):
    unregisterViews(root.service_view_registry)
    root.service_views.manage_delObjects(['SilvaExtETHLDAP'])

def is_installed(root):
    return hasattr(root.service_views, 'SilvaExtETHLDAP')

def registerViews(reg):
    """Register core views on registry.
    """
    # edit
    reg.register('edit', 'Silva ETH LDAP Member',
                 ['edit', 'Member', 'EthMember'])

def unregisterViews(reg):
    """Unregister core views on registry.
    """
    # edit
    reg.unregister('edit', 'Silva ETH LDAP Member')

def upgradeMemberObjects(root):
    memfolder = root.Members
    for memberobj in memfolder.objectValues():
        if IMember.isImplementedBy(memberobj):
            if not hasattr(memberobj, '_editor'):
                memberobj._editor = 'field_editor'

if __name__ == '__main__':
    print """This module is not an installer. You don't have to run it."""
